package com.redxun.knowledge.entity.vo;

import com.alibaba.fastjson.annotation.JSONField;
import com.baomidou.mybatisplus.annotation.TableField;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.redxun.knowledge.entity.dao.KnowledgeApprove;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Data
public class KnowledgeVo {
    // 主键
    private String pkId;

    // 知识分类ID
    private String categoryId;

    // 知识类型 1-文档知识 2-维基知识
    private Integer type;

    // 知识类型名称
    private String getTypeName() {
        if (type != null) {
            if (type == 1) {
                return "文档知识";
            } else if (type == 2) {
                return "维基知识";
            }
        }

        return "";
    }

    // 知识标题
    private String titles;

    // 作者名称
    private String author;

    // 知识内容
    private String content;

    // 简介
    private String summary;

    // 附件ID
    private String attachment;

    // 附件名
    private String attachmentName;

    // 创建时间
    @DateTimeFormat(
            pattern = "yyyy-MM-dd HH:mm:ss"
    )
    @JSONField(
            format = "yyyy-MM-dd HH:mm:ss"
    )
    @JsonFormat(
            pattern = "yyyy-MM-dd HH:mm:ss",
            timezone = "GMT+8"
    )
    private Date createTime;

    // 操作时间
    @DateTimeFormat(
            pattern = "yyyy-MM-dd HH:mm:ss"
    )
    @JSONField(
            format = "yyyy-MM-dd HH:mm:ss"
    )
    @JsonFormat(
            pattern = "yyyy-MM-dd HH:mm:ss",
            timezone = "GMT+8"
    )
    private Date updateTime;

    // 浏览数量
    private Integer views;

    // 审批状态 1-待节点审核 2-节点驳回 3-待最终审核 4-最终驳回 5-最终通过
    private Integer approvalStatus;

    // 创建人
    private String createBy;
    // 操作人
    private String updateBy;
    // 组织架构权限
    private String organizationId;

    // 流程节点
    private List<KnowledgeApprovalVo> approvals;

    // 第一个流程节点
    private KnowledgeApprove approvalsFirst;

    //所属分类
    private KnowledgeCategoryAdminVo knowledgeCategoryAdminVo;

    // 审核人Id
    private String approverId;

    // 操作人姓名
    private String operatorName;

    // 是否在当前组织架构权限中(0 在 1 不在 没最终通过时返回为null)
    private Integer isOrganizationId;

    //审批人名称;可以是人员或者部门名称
    private String approverName;

    //节点审核时间
    @DateTimeFormat(
            pattern = "yyyy-MM-dd HH:mm:ss"
    )
    @JSONField(
            format = "yyyy-MM-dd HH:mm:ss"
    )
    @JsonFormat(
            pattern = "yyyy-MM-dd HH:mm:ss",
            timezone = "GMT+8"
    )
    private Date approvalTime;

    // 其他参数
    private Map<String ,Object> params;

    // 审批结果
    private Integer result;

    // 知识Id
    private String knowledgerId;

    // 审批列表Id
    private String approveId;

    // 排序
    private Integer sort;
}
